import { redirect } from 'next/navigation';

import Layout from "@/components/Layout";

import Video from "@/components/Pages/Video";

import { fetchVideoData } from "@/utils/scrape/video";

import { useLocale } from 'next-intl';

export default async function VideoPage({ params }: { params: { id: string } }) {

  const locale = useLocale()

  const decodedId = decodeURIComponent(params.id)

  const [data, related] = await fetchVideoData(decodedId)

  if (!data.lowResUrl) {
    redirect(`/${locale}/404`)
  }
 
  return <Layout>
    <Video id={params.id} data={data} related={related}/>
  </Layout>
}