import { XVIDEOS_BASE_URL } from '@/constants/urls';
import { GalleryData, VideoData } from '@/meta/data';
import axios, { AxiosError } from 'axios';

import * as cheerio from "cheerio";

interface FetchParams {
    baseUrl?: string
    query?: string
}

export const fetchGalleryData = async (params?: FetchParams): Promise<GalleryData[]> => {

    let data: GalleryData[] = [];

    const reqHeaders = {
        headers: {
            "User-Agent": 'Mozilla/5.0 (Macintosh; Intel Mac OS X 11_14) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/109.0.5397.215 Safari/537.36'
        },
    };

    const queryUrl = `${(params && params.baseUrl) ?? XVIDEOS_BASE_URL}${params && params.query ? '/?k=' + params.query : ''}`

    await axios.get(queryUrl, reqHeaders)

        .then(response => {

            const html = response.data;

            const $ = cheerio.load(html);
        
            const thumbs = $(".thumb-block");
        
            thumbs.map((key, thumb) => {
        
                const videoUrl = $(thumb).find(".thumb a").attr("href")
                const imgUrl = $(thumb).find(".thumb img").attr("data-src")
                const text = $(thumb).find(".thumb-under a").attr("title")
        
                videoUrl && imgUrl && text && data.push({
                    videoUrl,
                    imgUrl,
                    text
                })
            })

        }).catch((error: AxiosError) => {
            // handle errors
        });


    return data
}